<template>
  <div
    class="dibs-synthesis--block"
    :class="{ 'dibs-synthesis--block--strong': strong }"
    :data-hide-info="hideInfo"
  >
    <dl class="dibs-synthesis--block--elem">
      <div v-if="title" class="dibs-synthesis--block--header">
        <!-- eslint-disable vue/no-v-html -->
        <h2 class="dibs-scrollbar" v-html="title" />
        <!-- eslint-enable vue/no-v-html -->
        <dibs-input-help
          v-if="withHelp"
          size="small"
          :is-round="true"
          @click="$emit('help')"
        >
          <dibs-picto-i />
        </dibs-input-help>
      </div>

      <!-- eslint-disable vue/no-v-html -->
      <div
        v-if="info"
        class="dibs-synthesis--block--header--precision"
        v-html="info"
      />
      <template v-if="info2">
        <div class="dibs-synthesis--block--h-divider" />
        <div
          class="dibs-synthesis--block--header--precision dibs-synthesis--block--scenario"
          v-html="info2"
        />
      </template>
      <!-- eslint-enable vue/no-v-html -->

      <div class="dibs-synthesis--block--w-divider" />

      <template v-for="(elem, id) in data">
        <dt
          :key="id + '-dt'"
          class="dibs-synthesis--block--elem--dt dibs-scrollbar"
          :class="{
            'dibs-synthesis--block--elem--small': elem.isSmall,
            'dibs-synthesis--block--elem--no-margin': elem.isSmall,
          }"
        >
          <dibs-input-close
            v-if="deleteLine"
            :key="id + '-delete'"
            class="dibs-synthesis--block--elem--label--delete"
            @click="$emit('delete', elem)"
          />
          <div class="dibs-synthesis--block--elem--label">
            {{ elem.label }}
          </div>
          <div v-if="elem.hint" class="dibs-synthesis--block--elem--precision">
            {{ elem.hint }}
          </div>
        </dt>
        <dd
          :key="id + '-dd'"
          class="dibs-synthesis--block--elem--dd"
          :class="{
            'dibs-synthesis--block--elem--small': elem.isSmall,
            'dibs-synthesis--block--elem--no-margin': elem.isSmall,
          }"
        >
          <div>
            {{ format(elem.value) }}
          </div>
        </dd>
        <template v-if="data2 && data2[id]">
          <div :key="id + '-2-hr'" class="dibs-synthesis--block--h-divider" />

          <dd
            :key="id + '-2-dd'"
            class="dibs-synthesis--block--elem--dd dibs-synthesis--block--scenario"
            :class="{
              'dibs-synthesis--block--elem--small': data2[id].isSmall,
              'dibs-synthesis--block--elem--no-margin': data2[id].isSmall,
            }"
          >
            <div>
              {{ format(data2[id].value) }}
            </div>
          </dd>
        </template>
      </template>

      <template v-for="(elem, id) in data">
        <template v-if="elem.label2">
          <dt
            :key="id + '-dt2'"
            class="dibs-synthesis--block--elem--dt dibs-scrollbar"
            :class="{ 'dibs-synthesis--block--elem--small': elem.isSmall }"
          >
            {{ elem.label2 }}
          </dt>
          <dd
            :key="id + '-dd2'"
            class="dibs-synthesis--block--elem--dd"
            :class="{ 'dibs-synthesis--block--elem--small': elem.isSmall }"
          >
            {{ format(elem.value2) }}
          </dd>
        </template>
        <div
          v-if="info2"
          :key="id + '-2-hr2'"
          class="dibs-synthesis--block--h-divider"
        />
        <template v-if="data2 && data2[id]">
          <template v-if="format(data2[id].value2)">
            <dd
              :key="id + '-2-dd2'"
              class="dibs-synthesis--block--elem--dd dibs-synthesis--block--scenario"
              :class="{
                'dibs-synthesis--block--elem--small': data2[id].isSmall,
              }"
            >
              {{ format(data2[id].value2) }}
            </dd>
          </template>
        </template>
      </template>

      <template v-if="action">
        <dt
          class="dibs-synthesis--block--elem--action dibs-scrollbar"
          @click="$emit('action')"
        >
          {{ action }}
        </dt>
        <template v-if="info2">
          <div class="dibs-synthesis--block--h-divider" />
          <div class="dibs-synthesis--block--h-divider" />
        </template>
        <template v-else> </template>
      </template>
      <template v-if="summary">
        <dt class="dibs-synthesis--block--elem--summary dibs-scrollbar">
          {{ summary.label }}
          <span
            v-if="summary.hint"
            class="dibs-synthesis--block--elem--precision"
            >{{ summary.hint }}</span
          >
        </dt>
        <dd class="dibs-synthesis--block--elem--summary dibs-scrollbar">
          {{ format(summary.value) }}
        </dd>
        <template v-if="summary2">
          <div v-if="data2" class="dibs-synthesis--block--h-divider" />
          <dd class="dibs-synthesis--block--elem--summary dibs-scrollbar">
            {{ format(summary2.value) }}
          </dd>
        </template>
      </template>
    </dl>
  </div>
</template>
<script>
export default {
  props: {
    title: {
      type: [String],
      required: false,
      default: null,
    },
    strong: {
      type: [Boolean],
      required: false,
      default: false,
    },
    info: {
      type: [String],
      required: false,
      default: null,
    },
    info2: {
      type: [String],
      required: false,
      default: null,
    },
    withHelp: {
      type: [Boolean],
      required: false,
      default: true,
    },
    hideInfo: {
      type: [Boolean],
      required: false,
      default: false,
    },
    deleteLine: {
      type: [Boolean],
      required: false,
      default: false,
    },
    data: {
      type: [Object, Array],
      required: true,
    },
    data2: {
      type: [Object, Array],
      required: false,
      default: () => null,
    },
    summary: {
      type: [Object],
      required: false,
      default: () => null,
    },
    summary2: {
      type: [Object],
      required: false,
      default: () => null,
    },
    action: {
      type: [String],
      required: false,
      default: null,
    },
  },
  data() {
    return {}
  },
  methods: {
    fixed(precision) {
      return this.between(0, precision, 20)
    },

    between(min, n, max) {
      return Math.max(min, Math.min(n, max))
    },
    numbersToCurrency(numbers, precision) {
      const exp = Math.pow(10, precision)
      const float = parseFloat(numbers) / exp
      return float.toFixed(this.fixed(precision))
    },
    onlyNumbers(input) {
      return this.toStr(input).replace(/\D+/g, '') || '0'
    },
    toStr(value) {
      return value ? value.toString() : ''
    },
    addThousandSeparator(integer, separator) {
      return integer.replace(/(\d)(?=(?:\d{3})+\b)/gm, `$1${separator}`)
    },
    joinIntegerAndDecimal(integer, decimal, separator) {
      return decimal ? integer + separator + decimal : integer
    },
    format(input) {
      if (!input) return
      const opt = {
        prefix: '',
        suffix: '',
        decimal: '.',
        thousands: '’',
        precision: 2,
        masked: false /* doesn't work with directive */,
      }

      if (typeof input === 'number') {
        input = input.toFixed(this.fixed(opt.precision))
      }
      // eslint-disable-next-line unicorn/prefer-includes
      const negative = input.indexOf('-') >= 0 ? '-' : ''

      const numbers = this.onlyNumbers(input)
      const currency = this.numbersToCurrency(numbers, opt.precision)
      const parts = this.toStr(currency).split('.')
      let integer = parts[0]
      const decimal = parts[1]
      integer = this.addThousandSeparator(integer, opt.thousands)
      return (
        opt.prefix +
        negative +
        this.joinIntegerAndDecimal(integer, decimal, opt.decimal) +
        opt.suffix
      )
    },
  },
}
</script>
<style></style>
